=== debian/changelog ===
indi (1.9.9+dfsg-3.1deepin1) unstable; urgency=medium

  * Rebuild

 -- Cryolitia <cryolitia@deepin.org>  Tue, 24 Jun 2025 14:50:30 +0800

indi (1.9.9+dfsg-3) unstable; urgency=medium

  * Backport upstream commit 4170c0ae30ac1df2e732392e38cb6aaae1802379 to fix
    the build with GCC 13; patch
    upstream_rawhideFix-add-missing-header-complained-about-with-.patch.
    (Closes: #1037696)
  * Update standards version to 4.6.2, no changes needed.

 -- Pino Toscano <pino@debian.org>  Sat, 15 Jul 2023 06:55:55 +0200

indi (1.9.9+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * Make sure to link with atomic on architectures that need it, i.e. riscv64.

 -- Pino Toscano <pino@debian.org>  Sat, 17 Dec 2022 09:23:13 +0100

indi (1.9.9+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.13
    - add libev-dev
  * Update the patches:
    - hurd_include.diff: refresh/update
  * Add the new binary package libindiclient1 for the libindiclient shared
    library.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Sat, 03 Dec 2022 17:47:34 +0100
